# Python bytecode 2.7 (decompiled from Python 2.7)
# Embedded file name: e:\jenkins\workspace\client_SERENITY\branches\release\SERENITY\carbon\client\script\graphics\interiorStaticClient.py
import cef
import collections
import service
import trinity
import blue

class InteriorStaticClientComponent:
    __guid__ = 'component.InteriorStaticClientComponent'


class InteriorStaticClient(service.Service):
    __guid__ = 'svc.interiorStaticClient'
    __componentTypes__ = [cef.InteriorStaticComponentView.GetComponentCodeName()]
    __dependencies__ = ['graphicClient']

    def CreateComponent(self, name, state):
        component = InteriorStaticClientComponent()
        if 'graphicID' in state:
            component.graphicID = state['graphicID']
        else:
            self.LogError('interiorStatic Component requires graphicID in its state')
            component.graphicID = 0
        component.cellName = state.get('cellName', 'DefaultCell')
        component.systemID = state.get('systemID', '0')
        component.objectID = state.get('objectID', 0)
        component.spawnID = state['_spawnID']
        component.enlightenOverrides = state.get('keyedData', {})
        component.depthOffset = float(state.get('depthOffset', 0))
        return component

    def ReportState(self, component, entity):
        report = collections.OrderedDict()
        report['graphicID'] = component.graphicID
        report['Position'] = component.renderObject.GetPosition()
        report['Rotation'] = component.renderObject.GetRotationYawPitchRoll()
        return report

    def PrepareComponent(self, sceneID, entityID, component):
        modelFile = self.graphicClient.GetModelFilePath(component.graphicID)
        component.entityID = entityID
        renderObject = trinity.Load(modelFile)
        renderObject.depthOffset = component.depthOffset
        renderObject.name = str(self.graphicClient.GetGraphicName(component.graphicID) + ': ' + str(entityID))
        component.renderObject = renderObject

    def SetupComponent(self, entity, component):
        positionComponent = entity.GetComponent('position')
        if positionComponent:
            component.renderObject.worldPosition = positionComponent.position
            component.renderObject.rotation = positionComponent.rotation
        scene = self.graphicClient.GetScene(entity.scene.sceneID)
        scene.AddStatic(component.renderObject, component.cellName, component.systemID, id=component.spawnID)

    def UnRegisterComponent(self, entity, component):
        self.graphicClient.GetScene(entity.scene.sceneID).RemoveStatic(component.renderObject)