# Python bytecode 2.7 (decompiled from Python 2.7)
# Embedded file name: e:\jenkins\workspace\client_SERENITY\branches\release\SERENITY\packages\carbonui\control\imagebutton.py
import carbonui.const as uiconst
import uthread
import blue
from carbonui.primitives.container import Container
from carbonui.primitives.sprite import Sprite
from carbonui.util.various_unsorted import MapIcon

class ImageButtonCore(Sprite):
    __guid__ = 'uicls.ImageButtonCore'
    default_name = 'imageButton'
    default_align = uiconst.RELATIVE
    default_label = ''
    default_width = 32
    default_height = 32
    default_idleIcon = None
    default_mousedownIcon = None
    default_mouseoverIcon = None
    default_onclick = None
    default_onclickargs = None
    default_getmenu = None
    default_expandonleft = False
    default_whilemousedownFunc = None

    def Close(self, *args, **kw):
        if self.whileMouseDownFuncTasklet and self.whileMouseDownFuncTasklet.alive:
            self.whileMouseDownFuncTasklet.kill()
        self.whileMouseDownFuncTasklet = None
        Sprite.Close(self, *args, **kw)
        return

    def ApplyAttributes(self, attributes):
        Sprite.ApplyAttributes(self, attributes)
        self.idleIcon = None
        self.mouseoverIcon = None
        self.mousedownIcon = None
        self.whileMouseDownFuncTasklet = None
        self.expandOnLeft = attributes.get('expandonleft', self.default_expandonleft)
        self.ClickFunc = attributes.get('onclick', self.default_onclick)
        self.ClickFuncArgs = attributes.get('onclickargs', self.default_onclickargs)
        self.GetMenu = attributes.get('getmenu', self.default_getmenu)
        self.WhileMouseDownFunc = attributes.get('whilemousedownFunc', self.default_whilemousedownFunc)
        self.SetMouseDownIcon(attributes.get('mousedownIcon', self.default_mousedownIcon), update=False)
        self.SetMouseOverIcon(attributes.get('mouseoverIcon', self.default_mouseoverIcon), update=False)
        self.SetMouseIdleIcon(attributes.get('idleIcon', self.default_idleIcon))
        return

    def OnClick(self, *args):
        if self.ClickFunc:
            if self.ClickFuncArgs:
                self.ClickFunc(*self.ClickFuncArgs)
            else:
                self.ClickFunc()

    def OnMouseDown(self, *args):
        self.UpdateIcon()
        if self.WhileMouseDownFunc:
            self.whileMouseDownFuncTasklet = uthread.worker('imageButtonCore::', self._WhileHandleMouseDownFunc)

    def _WhileHandleMouseDownFunc(self):
        lastTime = blue.os.GetWallclockTime()
        while True:
            if self.destroyed:
                return
            curTime = blue.os.GetWallclockTime()
            dt = float(curTime - lastTime) / const.SEC
            lastTime = curTime
            self.WhileMouseDownFunc(dt)
            blue.synchro.Yield()

    def OnMouseUp(self, *args):
        self.UpdateIcon()
        if self.whileMouseDownFuncTasklet and self.whileMouseDownFuncTasklet.alive:
            self.whileMouseDownFuncTasklet.kill()
            self.whileMouseDownFuncTasklet = None
        return

    def OnMouseEnter(self, *args):
        self.UpdateIcon()

    def OnMouseExit(self, *args):
        self.UpdateIcon()

    def SetMouseIdleIcon(self, icon, update=True):
        self.idleIcon = icon
        if update:
            self.UpdateIcon()

    def SetMouseDownIcon(self, icon, update=True):
        self.mousedownIcon = icon
        if update:
            self.UpdateIcon()

    def SetMouseOverIcon(self, icon, update=True):
        self.mouseoverIcon = icon
        if update:
            self.UpdateIcon()

    def UpdateIcon(self):
        mo = uicore.uilib.mouseOver
        if mo == self:
            if uicore.uilib.leftbtn:
                if self.mousedownIcon:
                    MapIcon(self, self.mousedownIcon, ignoreSize=True)
            elif self.mouseoverIcon:
                MapIcon(self, self.mouseoverIcon, ignoreSize=True)
        elif self.idleIcon:
            MapIcon(self, self.idleIcon, ignoreSize=True)