# Python bytecode 2.7 (decompiled from Python 2.7)
# Embedded file name: e:\jenkins\workspace\client_SERENITY\branches\release\SERENITY\eve\client\script\ui\shared\fittingGhost\ghostFittingPanels\minihangar.py
from carbonui.primitives.container import Container
from carbonui.primitives.fill import Fill
from eve.client.script.ui.shared.fittingGhost.fittingUtilGhost import GetColoredText
from inventorycommon.util import IsShipFittingFlag, IsShipFittable
import uicontrols
import uthread
import util
import carbonui.const as uiconst
import localization
import invCtrl
from utillib import KeyVal

class CargoSlots(Container):
    default_state = uiconst.UI_NORMAL

    def ApplyAttributes(self, attributes):
        Container.ApplyAttributes(self, attributes)
        self.controller = attributes.controller
        self.controller.on_stats_changed.connect(self.Update)
        invController = self.GetInvController()
        self.sr.icon = uicontrols.Icon(parent=self, size=32, state=uiconst.UI_DISABLED, ignoreSize=True, icon=invController.GetIconName())
        self.sr.hilite = Fill(parent=self, name='hilite', align=uiconst.RELATIVE, state=uiconst.UI_HIDDEN, idx=-1, width=32, height=self.height)
        self.sr.icon.color.a = 0.8
        Container(name='push', parent=self, align=uiconst.TOLEFT, width=32)
        self.sr.statusCont = Container(name='statusCont', parent=self, align=uiconst.TOLEFT, width=50)
        self.sr.statustext1 = uicontrols.EveLabelMedium(text='status', parent=self.sr.statusCont, name='cargo_statustext', left=0, top=2, idx=0, state=uiconst.UI_DISABLED, align=uiconst.TOPRIGHT)
        self.sr.statustext2 = uicontrols.EveLabelMedium(text='status', parent=self.sr.statusCont, name='cargo_statustext', left=0, top=14, idx=0, state=uiconst.UI_DISABLED, align=uiconst.TOPRIGHT)
        m3TextCont = Container(name='m3Cont', parent=self, align=uiconst.TOLEFT, width=12)
        self.sr.m3Text = uicontrols.EveLabelMedium(text=localization.GetByLabel('UI/Fitting/FittingWindow/CubicMeters'), parent=m3TextCont, name='m3', left=4, top=14, idx=0)
        sm.GetService('inv').Register(self)
        self.invReady = 1
        self.Update()

    def AddItem(self, item):
        self.Update()

    def UpdateItem(self, item, *etc):
        self.Update()

    def RemoveItem(self, item):
        self.Update()

    def OnMouseEnter(self, *args):
        self.DoMouseEntering()

    def OnMouseEnterDrone(self, *args):
        if eve.session.stationid:
            self.DoMouseEntering()

    def DoMouseEntering(self):
        self.Hilite(1)
        self.sr.statustext1.OnMouseEnter()
        self.sr.statustext2.OnMouseEnter()
        self.sr.m3Text.OnMouseEnter()

    def OnMouseExit(self, *args):
        self.Hilite(0)
        self.sr.statustext1.OnMouseExit()
        self.sr.statustext2.OnMouseExit()
        self.sr.m3Text.OnMouseExit()
        uthread.new(self.Update)

    def Hilite(self, state):
        self.sr.icon.color.a = [0.8, 1.0][state]

    def SetStatusText(self, text1, text2, color):
        self.sr.statustext1.text = text1
        self.sr.statustext2.text = localization.GetByLabel('UI/Fitting/FittingWindow/CargoUsage', color=color, text=text2)
        self.sr.statusCont.width = max(0, self.sr.statustext1.textwidth, self.sr.statustext2.textwidth)

    def OnDropData(self, dragObj, nodes):
        self.Hilite(0)

    def Update(self):
        uthread.new(self._Update)

    def _Update(self):
        cap = self.GetCapacity()
        if not cap:
            return
        if not self or self.destroyed:
            return
        capacityInfo = self.GetCapacityInfo()
        cap2 = capacityInfo.value
        used = util.FmtAmt(cap.used, showFraction=1)
        cap2 = util.FmtAmt(cap2, showFraction=1)
        coloredText = GetColoredText(isBetter=capacityInfo.isBetterThanBefore, text=cap2)
        self.SetStatusText(used, coloredText, '')

    def GetCapacity(self, flag=None):
        if self.controller.IsSimulated():
            return KeyVal(used=0)
        else:
            return self.GetInvController().GetCapacity()

    def GetCapacityInfo(self):
        pass

    def GetInvController(self):
        pass


class CargoDroneSlots(CargoSlots):

    def GetInvController(self):
        if self.controller.IsSimulated():
            itemID = None
        else:
            itemID = self.controller.GetItemID()
        return invCtrl.ShipDroneBay(itemID)

    def OnDropData(self, dragObj, nodes):
        invCtrl.ShipDroneBay(util.GetActiveShip()).OnDropData(nodes)
        CargoSlots.OnDropData(self, dragObj, nodes)

    def OnClick(self, *args):
        uicore.cmd.OpenDroneBayOfActiveShip()

    def GetCapacityInfo(self, flag=None):
        return self.controller.GetDroneCapacity()


class CargoCargoSlots(CargoSlots):

    def GetInvController(self):
        if self.controller.IsSimulated():
            itemID = None
        else:
            itemID = self.controller.GetItemID()
        return invCtrl.ShipCargo(itemID)

    def OnDropData(self, dragObj, nodes):
        self.Hilite(0)
        if len(nodes) == 1:
            item = nodes[0].item
            if IsShipFittingFlag(item.flagID):
                dogmaLocation = sm.GetService('clientDogmaIM').GetDogmaLocation()
                shipID = util.GetActiveShip()
                if IsShipFittable(item.categoryID):
                    dogmaLocation.UnloadModuleToContainer(shipID, item.itemID, (shipID,), flag=const.flagCargo)
                    return
                if item.categoryID == const.categoryCharge:
                    dogmaLocation.UnloadChargeToContainer(shipID, item.itemID, (shipID,), const.flagCargo)
                    return
        invCtrl.ShipCargo(util.GetActiveShip()).OnDropData(nodes)
        CargoSlots.OnDropData(self, dragObj, nodes)

    def OnClick(self, *args):
        uicore.cmd.OpenCargoHoldOfActiveShip()

    def GetCapacityInfo(self, flag=None):
        return self.controller.GetCargoCapacity()