# Python bytecode 2.7 (decompiled from Python 2.7)
# Embedded file name: e:\jenkins\workspace\client_SERENITY\branches\release\SERENITY\packages\trinity\__init__.py
import logging
import sys
import pytelemetry.zoning as telemetry
import walk
import uthread2
import os
try:
    import blue
except ImportError:
    import binbootstrapper
    binbootstrapper.update_binaries(__file__, binbootstrapper.DLL_BLUE, binbootstrapper.DLL_TRINITY)
    import blue

import _utils
_utils.AssertNotOnProxyOrServer()
from . import availablePlatforms
from ._singletons import *
from ._trinity import *
from .renderJob import CreateRenderJob
from .renderJobUtils import *
logger = logging.getLogger(__name__)

def GetEnumValueName(enumName, value):
    if enumName in globals():
        enum = globals()[enumName]
        result = ''
        for enumKeyName, (enumKeyValue, enumKeydocString) in enum.values.iteritems():
            if enumKeyValue == value:
                if result != '':
                    result += ' | '
                result += enumKeyName

        return result


def GetEnumValueNameAsBitMask(enumName, value):
    if enumName in globals():
        enum = globals()[enumName]
        result = ''
        for enumKeyName, (enumKeyValue, enumKeydocString) in enum.values.iteritems():
            if enumKeyValue & value == enumKeyValue:
                if result != '':
                    result += ' | '
                result += enumKeyName

        return result


def ConvertTriFileToGranny(path):
    helper = TriGeometryRes()
    return helper.ConvertTriFileToGranny(path)


def LoadDone(evt):
    evt.isDone = True


def WaitForResourceLoads():
    blue.resMan.Wait()


def WaitForUrgentResourceLoads():
    blue.resMan.WaitUrgent()


def LoadUrgent(path):
    blue.resMan.SetUrgentResourceLoads(True)
    obj = Load(path)
    blue.resMan.SetUrgentResourceLoads(False)
    return obj


def GetResourceUrgent(path, extra=''):
    blue.resMan.SetUrgentResourceLoads(True)
    obj = blue.resMan.GetResource(path, extra)
    blue.resMan.SetUrgentResourceLoads(False)
    return obj


def Save(obj, path):
    blue.motherLode.Delete(path)
    return blue.resMan.SaveObject(obj, path)


def SaveRenderTarget(filename, rt=None):
    if rt is None:
        rt = device.GetRenderContext().GetDefaultBackBuffer()
    if not rt.isReadable:
        readable = Tr2RenderTarget(rt.width, rt.height, 1, rt.format)
        rt.Resolve(readable)
        return Tr2HostBitmap(readable).Save(filename)
    else:
        return Tr2HostBitmap(rt).Save(filename)
        return


def _StoreGPUInfoInBreakpadHeaders():
    try:
        adapterInfo = adapters.GetAdapterInfo(adapters.DEFAULT_ADAPTER)
        blue.SetCrashKeyValues(u'GPU_Description', adapterInfo.description)
        blue.SetCrashKeyValues(u'GPU_Driver', unicode(adapterInfo.driver))
        blue.SetCrashKeyValues(u'GPU_VendorId', unicode(adapterInfo.vendorID))
        blue.SetCrashKeyValues(u'GPU_DeviceId', unicode(adapterInfo.deviceID))
        blue.SetCrashKeyValues(u'trinityPlatform', unicode(platform))
        try:
            driverInfo = adapterInfo.GetDriverInfo()
            blue.SetCrashKeyValues(u'GPU_Driver_Version', unicode(driverInfo.driverVersionString))
            blue.SetCrashKeyValues(u'GPU_Driver_Date', unicode(driverInfo.driverDate))
            blue.SetCrashKeyValues(u'GPU_Driver_Vendor', unicode(driverInfo.driverVendor))
            blue.SetCrashKeyValues(u'GPU_Driver_Is_Optimus', u'Yes' if driverInfo.isOptimus else u'No')
            blue.SetCrashKeyValues(u'GPU_Driver_Is_Amd_Switchable', u'Yes' if driverInfo.isAmdDynamicSwitchable else u'No')
        except RuntimeError:
            blue.SetCrashKeyValues(u'GPU_Driver_Version', unicode(adapterInfo.driverVersion))

    except RuntimeError:
        pass
    except SystemError:
        if platform == 'dx11':
            import log
            log.Quit('Video card may not support DX11 - setting preferred platform to DX9')


def IsFpsEnabled():
    return bool('FPS' in (j.name for j in renderJobs.recurring))


def SetFpsEnabled(enable, viewPort=None):
    if enable:
        if IsFpsEnabled():
            return
        fpsJob = CreateRenderJob('FPS')
        fpsJob.SetViewport(viewPort)
        fpsJob.RenderFps()
        fpsJob.ScheduleRecurring(insertFront=False)
    else:
        renderJobs.UnscheduleByName('FPS')


def AddRenderJobText(text, x, y, renderJob, color=4278255360L):
    steps = [ step for step in renderJob.steps if step.name == 'RenderDebug' ]
    if len(steps) > 0:
        step = steps[0]
    else:
        return
    step.Print2D(x, y, color, text)
    return renderJob


def CreateDebugRenderJob(renderJobName, viewPort, renderJobIndex=-1):
    renderJob = CreateRenderJob(renderJobName)
    renderJob.SetViewport(viewPort)
    step = renderJob.RenderDebug()
    step.name = 'RenderDebug'
    step.autoClear = False
    if renderJobIndex is -1:
        renderJob.ScheduleRecurring()
    else:
        renderJobs.recurring.insert(renderJobIndex, renderJob)
    return renderJob


def SetupDefaultGraphs():
    graphs.Clear()
    graphs.AddGraph('frameTime')
    graphs.AddGraph('devicePresent')
    graphs.AddGraph('primitiveCount')
    graphs.AddGraph('batchCount')
    graphs.AddGraph('pendingLoads')
    graphs.AddGraph('pendingPrepares')
    graphs.AddGraph('textureResBytes')


def AddFrameTimeMarker(name):
    line = GetLineGraphFrameTime()
    if line is not None:
        line.AddMarker(name)
    return


class FrameTimeMarkerStopwatch(object):

    def __init__(self, stopwatchName):
        self.started = blue.os.GetCycles()[0]
        self.stopwatchName = stopwatchName

    def __str__(self):
        return '%s %i ms' % (self.stopwatchName, int(1000 * ((blue.os.GetCycles()[0] - self.started) / float(blue.os.GetCycles()[1]))))

    def __del__(self):
        AddFrameTimeMarker(str(self))


def CreateBinding(cs, src, srcAttr, dst, dstAttr):
    binding = TriValueBinding()
    binding.sourceObject = src
    binding.sourceAttribute = srcAttr
    binding.destinationObject = dst
    binding.destinationAttribute = dstAttr
    if cs:
        cs.bindings.append(binding)
    return binding


def CreatePythonBinding(cs, src, srcAttr, dst, dstAttr):
    binding = Tr2PyValueBinding()
    binding.sourceObject = src
    binding.sourceAttribute = srcAttr
    binding.destinationObject = dst
    binding.destinationAttribute = dstAttr
    if cs:
        cs.bindings.append(binding)
    return binding


_isShaderLibraryInitialized = False
_isShaderLibraryPopulated = False

def PopulateShaderLibraryFromFiles():
    global _isShaderLibraryPopulated
    global _isShaderLibraryInitialized
    if _isShaderLibraryInitialized:
        return
    _isShaderLibraryInitialized = True

    def _AddToShaderLibrary(filepath):
        highLevelShader = blue.resMan.LoadObject(filepath)
        if highLevelShader is not None:
            try:
                shaderManager.shaderLibrary.append(highLevelShader)
            except Exception:
                logger.exception('Exception loading High Level Shader: %s', filepath)
                sys.exc_clear()

        else:
            logger.error('Unable to find shader library object: %s', filepath)
        return

    filesToLoad = set()
    for path, dirs, files in walk.walk('res:/Graphics/Shaders/ShaderDescriptions'):
        for f in files:
            filename, extension = os.path.splitext(f)
            if extension in ('.red', '.black'):
                filepath = path + '/' + filename + '.red'
                filesToLoad.add(filepath)

    uthread2.map(_AddToShaderLibrary, filesToLoad)
    _isShaderLibraryPopulated = True


SHADERLIBRARYFOLDER = 'res:/Graphics/Shaders'
SHADERLIBRARYFILENAME = SHADERLIBRARYFOLDER + '/ShaderDescriptions.red'

@telemetry.ZONE_FUNCTION
def PopulateShaderLibrary():
    global _isShaderLibraryPopulated
    global _isShaderLibraryInitialized
    if blue.paths.exists(SHADERLIBRARYFILENAME):
        if _isShaderLibraryInitialized:
            return
        _isShaderLibraryInitialized = True
        shaders = blue.resMan.LoadObject(SHADERLIBRARYFILENAME)
        shaderManager.shaderLibrary = shaders.shaderLibrary
        _isShaderLibraryPopulated = True
    else:
        PopulateShaderLibraryFromFiles()


def IsShaderLibraryPopulated():
    return _isShaderLibraryPopulated


def IsMsaaTypeSupported(msaa_type, formats):
    supported = True
    for surface_format in formats:
        args = (device.adapter,
         surface_format[0],
         app.windowed,
         msaa_type)
        try:
            if surface_format[1]:
                quality_levels = adapters.GetRenderTargetMsaaSupport(*args)
            else:
                quality_levels = adapters.GetDepthStencilMsaaSupport(*args)
        except _trinity.ALInvalidCallError:
            quality_levels = 0

        supported = supported and quality_levels

    return supported


def GetHighestSupportedMsaaType(formats):
    levels = (8, 6, 4, 2)
    for each in levels:
        if IsMsaaTypeSupported(each, formats):
            return each


def _init():
    _StoreGPUInfoInBreakpadHeaders()
    device.SetRenderJobs(renderJobs)
    if not blue.pyos.packaged:
        SetFpsEnabled(True)


_init()